package com.hzya.frame.u8.delivery.service.impl;

import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.dynamic.datasource.annotation.DS;
import com.hzya.frame.basedao.service.impl.BaseService;
import com.hzya.frame.u8.delivery.dao.IDeliveryOrderDao;
import com.hzya.frame.u8.delivery.entity.DeliveryOrderEntity;
import com.hzya.frame.u8.delivery.service.IDeliveryOrderService;
import com.hzya.frame.web.entity.BaseResult;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @Description U8发货单
 * @Author xiangerlin
 * @Date 2024/8/22 15:13
 **/
@Service(value = "DeliveryOrderServiceImpl")
public class DeliveryOrderServiceImpl extends BaseService<DeliveryOrderEntity,String> implements IDeliveryOrderService {
    Logger logger = LogManager.getLogger(getClass());
    private IDeliveryOrderDao deliveryOrderDao;

    @Autowired
    public void setDeliveryOrderDao(IDeliveryOrderDao dao) {
        this.deliveryOrderDao = dao;
        this.dao = dao;
    }

    /**
     * 保存自定义项
     *
     * @param entity
     */
    @Override
    @DS("#entity.dataSourceCode")
    public void saveExtradefine(DeliveryOrderEntity entity) {
        deliveryOrderDao.save("com.hzya.frame.u8.delivery.dao.impl.DeliveryOrderDaoImpl.dispatchList_order_extradefine_insert",entity);
    }

    @Override
    public JsonResultEntity editDelivery(String parm) {
        JSONObject jsonObject = JSONObject.parseObject(parm);
        String cdlcode = jsonObject.getString("cdlCode");
        String AccId = jsonObject.getString("AccId");
        String frozen = jsonObject.getString("frozen");
        switch (AccId){
            case "001":
                AccId = "UFDATA_001_2023";
            break;
            case "002":
                AccId = "UFDATA_002_2024";
                break;
            case "004":
                AccId = "UFDATA_004_2023";
                break;
            case "005":
                AccId = "UFDATA_005_2023";
                break;
            case "021":
                AccId = "UFDATA_201_2023";
                break;
            default:
                return BaseResult.getFailureMessageEntity("清传入正确的账套号");
        }
        if("frozen".equals("Y")||"frozen".equals("N")){
            if(StrUtil.isEmpty(cdlcode)){
                return BaseResult.getFailureMessageEntity("发货单号不能为空");
            }
            if(StrUtil.isEmpty(AccId)){
                return BaseResult.getFailureMessageEntity("账套号不能为空");
            }
            DeliveryOrderEntity entity = new DeliveryOrderEntity();
            entity.setAccId(AccId);
            entity.setCdlcode(cdlcode);
            entity.setFrozen(frozen);
            deliveryOrderDao.update("com.hzya.frame.u8.delivery.dao.impl.DeliveryOrderDaoImpl.entity_update",entity);
            return BaseResult.getSuccessMessageEntity("更新成功");
        }else{
            return BaseResult.getFailureMessageEntity("清传入正确的状态Y=冻结 N=解冻");
        }

    }
}
